package com.thebrokenrail.scriptcraft.api.util;

import java.util.Locale;

@SuppressWarnings("UnnecessaryUnboxing")
public class ValueUtil {
    public static <T extends Enum<T>> T getEnumValue(Class<T> clazz, String value, T defaultValue) {
        try {
            return Enum.valueOf(clazz, value.toUpperCase(Locale.ROOT));
        } catch (NullPointerException e) {
            return defaultValue;
        }
    }

    public static double toDouble(Object value, double defaultValue) {
        try {
            return ((Double) value).doubleValue();
        } catch (NullPointerException e) {
            return defaultValue;
        }
    }
}
